// mfcView.h : interface of the CMfcView class
//
/////////////////////////////////////////////////////////////////////////////
#include <GL/gl.h>
#include <GL/glu.h>
#ifndef _CANVAS
#include "canvas.hpp"
#endif

class CMfcView : public CView
{
protected: // create from serialization only
	CMfcView();
	DECLARE_DYNCREATE(CMfcView)

// Attributes
public:
	CMfcDoc* GetDocument();

// Operations
public:
	GLfloat m_xRotate;
	GLfloat m_yRotate;
	GLfloat m_zRotate;

	GLfloat m_xScale;
	GLfloat m_yScale;
	GLfloat m_zScale;

	GLfloat m_xTranslate;
	GLfloat m_yTranslate;
	GLfloat m_zTranslate;

	int m_GLPixelIndex;
	GLfloat m_yaw;

	BOOL m_animate;
	BOOL m_cone_flag;
	BOOL m_sphere_flag;
	BOOL m_cylinder_flag;

	Canvas m_canvas;


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMfcView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMfcView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	HGLRC m_hRC;
	HPALETTE m_hPalette;
	void DrawWithOpenGL();
	void setPerspectiveWindow(GLdouble fovy, GLdouble aspect,GLdouble zNear,GLdouble zFar);
	void setViewport(GLint iX, GLint iY, GLsizei iWidth, GLsizei iHeight);
	void setDepthBuffer();
	void setupLogicalPalette();
	void processGeometry();
// Generated message map functions
protected:
	//{{AFX_MSG(CMfcView)
	afx_msg void OnTransformRotate();
	afx_msg void OnTransformScale();
	afx_msg void OnTransformTranslate();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnTransformAnimate();
	afx_msg void OnObjectsSphere();
	afx_msg void OnUpdateObjectsSphere(CCmdUI* pCmdUI);
	afx_msg void OnObjectsCone();
	afx_msg void OnUpdateObjectsCone(CCmdUI* pCmdUI);
	afx_msg void OnObjectsCylinder();
	afx_msg void OnUpdateObjectsCylinder(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in mfcView.cpp
inline CMfcDoc* CMfcView::GetDocument()
   { return (CMfcDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
